tigase.xmpp.impl

## Class DomainFilter

- java.lang.Object
- - tigase.xmpp.XMPPProcessor
  - - tigase.xmpp.impl.DomainFilter

- All Implemented Interfaces:
    Comparable<XMPPImplIfc>, XMPPImplIfc, XMPPPacketFilterIfc, XMPPPreprocessorIfc

      public class DomainFilter
      extends XMPPProcessor
      implements XMPPPacketFilterIfc, XMPPPreprocessorIfc

  Created: Dec 30, 2008 12:43:28 PM
  Author:
    Artur Hefczyc

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `ALLOWED_DOMAINS_KEY` constant domain key name
    `static String` | `ALLOWED_DOMAINS_LIST_KEY` constant domain list key name

    - ### Fields inherited from class tigase.xmpp.XMPPProcessor

      `ALL_NAMES, ALL_PATHS, cmpInfo`

    - ### Fields inherited from interface tigase.xmpp.XMPPImplIfc

      `CLIENT_XMLNS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DomainFilter()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `filter(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results)`
    `DomainFilterPolicy` | `getDomains(XMPPResourceConnection session)` Method retrieves filtering policy based on user session, from most specific to most general, i.e.: first user session is checked, if that fails then user repository and if there is no rules configured then domain filtering policy from VHost is being returned (if present).
    `String[]` | `getDomainsList(XMPPResourceConnection session)` Method retrieves list of domains to be applied to `LIST` and `BLACKLIST` filtering policies based on user session, from most specific to most general, i.e.: first user session is checked, if that fails then user repository and if there is no rules configured then list of domains from VHost is being returned (if present).
    `String` | `id()` Method `id` returns a unique ID of the plugin.
    `void` | `init(Map<String,Object> settings)` Method `init` is called just after the plugin has been loaded into memory.
    `boolean` | `preProcess(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)` Performs pre-processing of `packet`.
    `String[][]` | `supElementNamePaths()` Method `supElementNamePaths` returns an array of element names in form of a full path to the XML element for stanzas which can be processed by this plugin.
    `String[]` | `supNamespaces()` Method `supNamespaces` returns an array of name-spaces for stanzas which can be processed by this plugin.

    - ### Methods inherited from class tigase.xmpp.XMPPProcessor

      `canHandle, compareTo, concurrentThreadsPerQueue, getComponentInfo, getInstance, getStatistics, isSupporting, supDiscoFeatures, supElements, supStreamFeatures, supTypes, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface tigase.xmpp.XMPPImplIfc

      `canHandle, concurrentQueuesNo, concurrentThreadsPerQueue, getComponentInfo, getStatistics, isSupporting, supDiscoFeatures, supElements, supStreamFeatures, supTypes`

    - ### Methods inherited from interface java.lang.Comparable

      `compareTo`

- - ### Field Detail

    - #### ALLOWED_DOMAINS_KEY

          public static final String ALLOWED_DOMAINS_KEY

      constant domain key name
      See Also:
        Constant Field Values

    - #### ALLOWED_DOMAINS_LIST_KEY

          public static final String ALLOWED_DOMAINS_LIST_KEY

      constant domain list key name
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### DomainFilter

          public DomainFilter()

  - ### Method Detail

    - #### filter

          public void filter(Packet packet,
                             XMPPResourceConnection session,
                             NonAuthUserRepository repo,
                             Queue<Packet> results)

      Specified by:
        `filter` in interface `XMPPPacketFilterIfc`

    - #### id

          public String id()

      Description copied from interface: `XMPPImplIfc`
      Method `id` returns a unique ID of the plugin. Each plugin has own, unique ID which is used in the configuration file to determine whether it needs to be loaded or not. In most cases the ID can be equal to XMLNS of the packages processed by the plugin.
      Specified by:
        `id` in interface `XMPPImplIfc`
      Returns:
        a `String` value

    - #### init

          public void init(Map<String,Object> settings)
                    throws TigaseDBException

      Description copied from interface: `XMPPImplIfc`
      Method `init` is called just after the plugin has been loaded into memory. The idea behind this is to allow it to initialize or check the database. This might be especially useful for plugins which want to have a database access via non-standard stored procedures or need schema upgrade.
      Specified by:
        `init` in interface `XMPPImplIfc`
      Overrides:
        `init` in class `XMPPProcessor`
      Parameters:
        `settings` - is a Map with initial processor settings from the configuration file.
      Throws:
        `TigaseDBException`

    - #### preProcess

          public boolean preProcess(Packet packet,
                                    XMPPResourceConnection session,
                                    NonAuthUserRepository repo,
                                    Queue<Packet> results,
                                    Map<String,Object> settings)

      Description copied from interface: `XMPPPreprocessorIfc`
      Performs pre-processing of `packet`. Intention for the pre-processors is to allow them for packet blocking.
      Specified by:
        `preProcess` in interface `XMPPPreprocessorIfc`
      Parameters:
        `packet` - packet is which being processed. This parameter may never be null. Even though this is not immutable object it mustn't be altered. None of it's fields or attributes can be changed during processing.
        `session` - user session which keeps all the user session data and also gives an access to the user's repository data. It allows for storing information in a permanent storage or in memory only during the live of the online session. This parameter can be null if there is no online user session at the time of the packet processing.
        `repo` - this is a user data storage which is normally used when the user session (parameter above) is null. This is repository allows for a very restricted access only. It allows for storing some user private data (doesn't allow overwriting existing data) like messages for offline users and it also allows for reading user public data like VCard.
        `results` - this a collection with packets which have been generated as input packet processing results. Regardless a response to a user request is sent or the packet is forwarded to it's destination it is always required that a copy of the input packet is created and stored in the results queue.
        `settings` - this map keeps plugin specific settings loaded from the Tigase server configuration. In most cases it is unused, however if the plugin needs to access an external database that this is a way to pass database connection string to the plugin.
      Returns:
        the pre-processing result; if the value is ‘true’ then the packet is blocked and no further processing is performed.

    - #### supElementNamePaths

          public String[][] supElementNamePaths()

      Description copied from interface: `XMPPImplIfc`
      Method `supElementNamePaths` returns an array of element names in form of a full path to the XML element for stanzas which can be processed by this plugin. Each element name path corresponds to XMLNS returned in array by `supNamespaces()` method. The element path itself is represented by a String array with each path element as a separate String.
      Specified by:
        `supElementNamePaths` in interface `XMPPImplIfc`
      Overrides:
        `supElementNamePaths` in class `XMPPProcessor`
      Returns:
        a `String[][]` value is an array for element paths for which the plugin offers processing capabilities. Each path is in form of a String array in order to reduce parsing overhead.

    - #### supNamespaces

          public String[] supNamespaces()

      Description copied from interface: `XMPPImplIfc`
      Method `supNamespaces` returns an array of name-spaces for stanzas which can be processed by this plugin. Each namespace corresponds to element name returned in array by `supElemenets()` method.
      Specified by:
        `supNamespaces` in interface `XMPPImplIfc`
      Overrides:
        `supNamespaces` in class `XMPPProcessor`
      Returns:
        a `String[]` value

    - #### getDomains

          public DomainFilterPolicy getDomains(XMPPResourceConnection session)
                                        throws NotAuthorizedException,
                                               TigaseDBException

      Method retrieves filtering policy based on user session, from most specific to most general, i.e.: first user session is checked, if that fails then user repository and if there is no rules configured then domain filtering policy from VHost is being returned (if present).
      Parameters:
        `session` - user session which keeps all the user session data and also gives an access to the user's repository data. It allows for storing information in a permanent storage or in memory only during the live of the online session. This parameter can be null if there is no online user session at the time of the packet processing.
      Returns:
        relevant domain filtering policy
      Throws:
        `NotAuthorizedException`
        `TigaseDBException`

    - #### getDomainsList

          public String[] getDomainsList(XMPPResourceConnection session)
                                  throws NotAuthorizedException,
                                         TigaseDBException

      Method retrieves list of domains to be applied to `LIST` and `BLACKLIST` filtering policies based on user session, from most specific to most general, i.e.: first user session is checked, if that fails then user repository and if there is no rules configured then list of domains from VHost is being returned (if present).
      Parameters:
        `session` - user session which keeps all the user session data and also gives an access to the user's repository data. It allows for storing information in a permanent storage or in memory only during the live of the online session. This parameter can be null if there is no online user session at the time of the packet processing.
      Returns:
        list of domains to be whitelisted/blacklisted
      Throws:
        `NotAuthorizedException`
        `TigaseDBException`

Copyright © 2017 "Tigase, Inc.". All rights reserved.